package timon.de.print;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.support.v4.print.PrintHelper;
import android.util.Base64;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** PrintPlugin */
public class PrintPlugin implements MethodCallHandler {
  /** Plugin registration. */
  private Activity context;

  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "print");
    channel.setMethodCallHandler(new PrintPlugin(registrar.activity(), channel));
  }

  public PrintPlugin(Activity activity, MethodChannel methodChannel){
    this.context = activity;
    methodChannel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("printImage")) {
      Bitmap image = getBitmapFromPath((String) call.argument("imagePath"));
      printImage(image);
      result.success("printingImage");
    } else {
      result.notImplemented();
    }
  }

  private Bitmap getBitmapFromPath(String path) {
    return BitmapFactory.decodeFile(path);
  }
  private void printImage(Bitmap image){
    PrintHelper photoPrinter = new PrintHelper(context);
    photoPrinter.setScaleMode(PrintHelper.SCALE_MODE_FIT);
    photoPrinter.printBitmap("QR-Code", image);
  }
}
