import 'dart:async';
import 'dart:typed_data';
import 'dart:io';

import 'package:flutter/services.dart';
import 'package:path_provider/path_provider.dart';

const MethodChannel _channel = const MethodChannel('print');

Future<void> printImage(String path) async {
  await _channel.invokeMethod('printImage', {"imagePath": path});
}

///[imageBytes] is the byte representation of an image - not a ARGB representation
Future<void> printImageBytes(Uint8List imageBytes) async {
  File file =
      await File("${(await getTemporaryDirectory()).path}/temp_print_image.png")
          .writeAsBytes(imageBytes);
  await printImage(file.path);
}
